--[[
Spamcast, anti-message repetition
By Castdead, Kazzak EU
]]

local spamcast = {}
spamcast.options = {}
spamcast.status = {}
local messageTable = {}
spamcast.status.enabled = true;
spamcast.status.messages = 0
spamcast.status.tablesize = 0
spamcast.options["cooldown"] = 90
spamcast.options["cleanuptime"] = 30

spamcast.status.operatingTime = GetTime()

--[[
	Function to print messages in yellow
]]

local function printmessage(txt)
	DEFAULT_CHAT_FRAME:AddMessage(txt, 1.0, 1.0, 0.0);
end

--[[
	Function to handle CHAT_MSG_CHANNEL events
]]

spamcast.frame = CreateFrame("FRAME", "SpamCast");
spamcast.frame:RegisterEvent("CHAT_MSG_CHANNEL");
local function eventHandler(self, event, ...)
	if event == "CHAT_MSG_CHANNEL" then
		ctime = time()
		cmessage = strtrim(arg1, " ")
		cauthor = arg2
		clowerkey = string.lower(cauthor.."_"..cmessage)
		if messageTable[clowerkey] == nil then
				messageTable[clowerkey] = ctime-1
		end		
	end
end
spamcast.frame:SetScript("OnEvent", eventHandler);


--[[
	Function to remove unnecessary data from the message table
]]

local function CleanUpTables(ctime)
	local size = 0
	for k, v in pairs(messageTable) do
		if ctime - v > spamcast.options["cooldown"] then
			messageTable[k] = nil
		end
		size = size+1
	end	
	spamcast.status.tablesize = size
end

--[[
	Function to filter out repetitive messages
]]

local function filter(frame, event, ...)
	ctime = GetTime()
	cmessage = strtrim(arg1, " ")
	cauthor = arg2
	clowerkey = string.lower(cauthor.."_"..cmessage)
	
	if ctime - spamcast.status.operatingTime > spamcast.options["cleanuptime"] then
		CleanUpTables(ctime)
		spamcast.status.operatingTime = GetTime()
	end
	if messageTable[clowerkey] == nil or ctime - messageTable[clowerkey] < 0.0015 then
		messageTable[clowerkey] = ctime
		return false, cmessage, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12
	else
		if ctime - messageTable[clowerkey] > spamcast.options["cooldown"] then
			messageTable[clowerkey] = ctime
			return false, cmessage, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12
		else 
			return true;
		end		
	end
	
    return true
end

--[[
	slash command handler
]]

SLASH_SPAMCAST1, SLASH_SPAMCAST2, SLASH_SPAMCAST3 = '/spamcast', '/spamc', '/sc';
local function slashCmdHandler(msg, editbox)
	local errormessage = false
	local strstatus = ""
	local command, rest = msg:match("^(%S*)%s*(.-)$");
	if command == "enable" then
		spamcast.status.enabled = true
		ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", filter)
		printmessage("Spamcast is now enabled")
	elseif command == "disable"then
		spamcast.status.enabled = false
		ChatFrame_RemoveMessageEventFilter("CHAT_MSG_CHANNEL", filter)
		printmessage("Spamcast is now disabled")
	elseif command == "status" then
		if spamcast.status.enabled then
			strstatus = "enabled"
		else
			strstatus = "disabled"
		end
		printmessage("Spamcast is "..strstatus..". Cooldown is "..spamcast.options["cooldown"] .." seconds , clean up time is "..spamcast.options["cleanuptime"].." seconds. Size of table is ".. spamcast.status.tablesize.. " records.")
	elseif command == "cooldown" then
		rest = tonumber(rest)
		if rest ~= nil then
			if rest >= 10 and rest <= 300 then
				spamcast.options["cooldown"] = rest
				printmessage("Cooldown is now "..rest.." seconds.")
			else
				printmessage("Cooldown must be within 10 and 300 (in seconds)");
			end
		else
			errormessage = true
		end
	elseif command == "cleanup"then
		rest = tonumber(rest)
		if rest ~= nil then
			if rest >= 10 and rest <= 300 then
				spamcast.options["cleanuptime"] = rest
				printmessage("Clean up time is now "..rest.." seconds.")
			else
				printmessage("Clean up time must be within 10 and 300 (in seconds)");
			end
		else
			errormessage = true
		end
	else
		errormessage = true
	end
	if errormessage then
		printmessage("Syntaxis: /spamcast enable|disable|status|cooldown 10-300|cleanup 10-300");
	end
end
SlashCmdList["SPAMCAST"] = slashCmdHandler;


ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", filter)